import * as React from "react";
import ReactDOM from "react-dom/client";
import document from "global/document";

import { applyMiddleware, combineReducers, compose, createStore } from "redux";
import { connect, Provider } from "react-redux";

import keplerGlReducer, { enhanceReduxMiddleware } from "@kepler.gl/reducers";
import KeplerGl from "@kepler.gl/components";

import AutoSizer from "react-virtualized/dist/commonjs/AutoSizer";

// create reducers
const reducers = combineReducers({
  // mount keplerGl reducer
  keplerGl: keplerGlReducer.initialState({
    uiState: {
      readOnly: false,
      currentModal: null,
    },
  }),
});

// create middlewares
const middleWares = enhanceReduxMiddleware([
  // Add other middlewares here
]);

// craeteEnhancers
const enhancers = applyMiddleware(...middleWares);

// create store
const initialState = {};
const store = createStore(reducers, initialState, compose(enhancers));

const App2 = () => (
  <div
    style={{
      position: "absolute",
      top: "0px",
      left: "0px",
      width: "100%",
      height: "100%",
    }}
  >
    <AutoSizer>
      {({ height, width }) => (
        <KeplerGl
          mapboxApiAccessToken="xxx"
          id="map"
          width={width}
          height={height}
        />
      )}
    </AutoSizer>
  </div>
);

const mapStateToProps = (state) => state;
const dispatchToProps = (dispatch) => ({ dispatch });
const ConnectedApp = connect(mapStateToProps, dispatchToProps)(App2);
const Root = () => (
  <Provider store={store}>
    <App2 />
  </Provider>
);

const container = document.getElementById("root");
const root = ReactDOM.createRoot(container);
root.render(<Root />);
